/**
   Lanciate questa classe per fare una prova...
   @author Andrea Trentini
*/
public class Main
{
   public static void main(String arg[]) throws Exception
   {
      // creo il caretaker
      SerialStorage s = new SerialStorage("storage");
      Html.prt(s);

      // creo l'oggetto di cui voglio memorizzare gli stati
      TestPersistent p = new TestPersistent("prova",7);
      Html.prt(p);

      // salvo lo stato
      s.saveState(p.spawnState());

      // cambio lo stato dell'oggetto
      p.modify();
      Html.prt(p);

      // recupero lo stato originario
      p.absorbState(s.retrieveState("prova"));
      Html.prt(p);

      // ORA CON L'ALTRO PERSISTENT (NOTATE CHE NON CAMBIO STORAGE!!!)

      // creo l'oggetto di cui voglio memorizzare gli stati (properties)
      TestPersistentProp pp = new TestPersistentProp("prova_p",77);
      Html.prt(pp);

      // salvo lo stato
      s.saveState(pp.spawnState());

      // cambio lo stato dell'oggetto
      pp.modify();
      Html.prt(pp);

      // recupero lo stato originario
      pp.absorbState(s.retrieveState("prova_p"));
      Html.prt(pp);
   }
}
